﻿#title = "行コメント"
#tooltip = "Ctrl: 強制コメントアウト / Shift: ブックマーク保護"
#icon = "Mery用 マテリアルデザインっぽいアイコン.icl",215
#begingroup = 3
// #title = "行ｺﾒﾝﾄ"
// #icon = "double-slash[2].ico"
// #tooltip = "コメントマーク付けはずし"

var start = new Date();	// 所要時間計測（開始）
var d = editor.ActiveDocument;

var $ctrl = 0;
var gks = editor.FullName.replace( /[^\\]+\.exe$/i , "" )
        + "Macros\\GetKeyState.exe";
if ( new ActiveXObject( "Scripting.FileSystemObject" ).FileExists( gks ) ) {
  var WshShell = new ActiveXObject( "WScript.Shell" );
  // Ctrl キーの状態を取得
  $ctrl = WshShell.Run( '"' + gks + '" ctrl', 0, true );
}

/**
 * --------------------------------------------------------------
 * 「行コメント」マクロ （コメントマーク付け外し sukemaru版）
 *   Orginal created by 手石 & masme, 2013/03/28 - 2016/02/28
 *   Modified by        sukemaru,     2018/10/28 - 2019/11/10
 * --------------------------------------------------------------
 * マクロライブラリに転載済み (2018/10/28 - 2019/11/10)
 * ref. https://www.haijin-boys.com/wiki/コメントマーク付け外し
 *      https://www.haijin-boys.com/wiki/%E3%82%B3%E3%83%A1%E3%83%B3%E3%83%88%E3%83%9E%E3%83%BC%E3%82%AF%E4%BB%98%E3%81%91%E5%A4%96%E3%81%97
 * --------------------------------------------------------------
 * ※ このマクロは、以下の外部実行ファイルで機能拡張できる
 * ・pizz 氏作成の "GetKeyState.exe(キー状態取得実行ファイル)" を
 *   マクロライブラリからダウンロードして "Mery\Macros" フォルダに をZIP 解凍する
 *  https://www.haijin-boys.com/wiki/GetKeyState.exe%28%E3%82%AD%E3%83%BC%E7%8A%B6%E6%85%8B%E5%8F%96%E5%BE%97%E5%AE%9F%E8%A1%8C%E3%83%95%E3%82%A1%E3%82%A4%E3%83%AB%29
 * --------------------------------------------------------------
 */

// ---------- ▼ 設定項目 ▼ ---------- //

// ● 行の途中にある選択範囲をコメントアウトするか？
var inLineEnable = true;	// (※初期値 true )
  /**
   * true  ならインラインコメントアウトする
   *   ※ 選択範囲が１行内のとき、選択範囲の先頭位置でコメントアウト／アンコメント
   * false ならインラインコメントアウトしない
   *   ※ 選択範囲のある行の先頭位置でコメントアウト／アンコメント
   */

// ● 字下げされたコメントマークも削除するか？
var mode = 3;	// (※初期値 3 )
  /**
   * mode = 0; なら 追加／削除 する位置は「常に行頭」のみ（字下げされたコメントマークは削除しない）
   * ※ 1 ～ 4  なら字下げされたコメントマークも削除する。追加する位置は以下のとおり。
   * mode = 1; なら「常に先頭」にコメントマークを追加する（例１.の使い方 ※従来版の挿入パターン）
   * ※ 2 ～ 4  なら追加する位置は字下げに対応可。
   * mode = 2; なら追加と削除で同じ判定基準の先頭位置検出をする（例２.の使い方ができる）
   * mode = 3; なら追加と削除で別々の判定基準の先頭位置検出をする（例３.の使い方）
   * mode = 4; なら「常に各行の字下げ位置」にあわせてコメントマークを追加する（例４.の使い方）
   */

// ◆ コメントマーク末尾に空白つきで定義しているときに、末尾空白のないコメントマークも削除するか？
var varEnable = true;	// (※初期値 true )
  /**
   * ※ comment = "// ";  のときに  "//こういうコメント行"  もアンコメントするか？
   * true  なら削除する
   * false なら削除しない
   * ※ 再度コメントアウトするさいは comment で定義したコメントマーク（末尾空白つき）になる。
   *   コメントマーク comment を末尾に空白なしで定義した場合は無視する。
   */


// ■ 行コメント文字の定義  (※初期値  "// " )
var comment = "// ";
  /**
   * ※ ver 2018/11/14 以降はコメントマークの定義に "末尾空白" ありがデフォルト
   * 「var comment = "> ";」にするか、下の定義切替ブロックに
   * 「case "text":  return "> ";」を追加すると、引用マークの付けはずしにもなる
   */


// ▼ コメントマークの定義切替  ▼
comment = ( function() {

  // ▼ 拡張子による定義切り替え ▼
  if ( d.Name.match( /\.def$|\.asm$|\.reg$|\.key$|\.inf$/i ) ) {
    return "; ";
  }

  // ▼ ファイル名による定義切り替え ▼
  else if ( d.Name.match( /^hosts$/i ) ) {
    return "# ";
  }

  // // ▼ ファイル名による定義切り替え ▼
  // else if ( d.Name.toLowerCase() == "hoge.txt" ) {
  //   return "> ";
  // }

  // // ▼ フォルダ名による定義切り替え（正規表現） ▼
  // else if ( d.FullName.match( /\\FUGA\\(?!PIYO\\)/i ) ) {
  //   return "> ";
  // }

  // ▼ 編集モードによる定義切り替え ▼
  else {
    switch ( document.Mode.toLowerCase() ) {
      case "text":
        return "> ";
      case "bat":
        return ":: ";	// return "REM ";	// ": " や "' " でも可
      case "c#":  case "c++":  case "delphi":  case "java":
      case "javascript":  case "jsp":  case "windows script": 
      case "mery_macro_js":  case "mery_macros_js": 
      case "mery macro js":  case "mery macros js":  
      case "janestyle （正規表現用）":
        return "// ";
      case "ini":  case "mery msy":
        return "# ";
      case "perl":  case "perlscript":  case "php":  
      case "python":  case "ruby":   case "powershell":
      case: "ini":  case "mery msy":		// ini は "; " でも可
        return "# ";
      case "visualbasic":  case "vbscript":
        return "' ";
      case "hsp":  case "autohotkey":
        return "; ";
      case "sql":
        return "-- ";
      case "tex":
        return "% ";
      default:
        return comment;
    }
  }

} )();

// ---------- ▲ 設定項目 ▲ ---------- //


// ドキュメントが書き換え禁止ならマクロを閉じる
if ( editor.ActiveDocument.ReadOnly ) {
  Status = "　ドキュメントは書き換え禁止です。";
}
// コメントマークが空白文字だけならマクロを閉じる
else if ( /^\s*$/.test( comment ) ) {
  Status = "　コメントマークの定義が無効です。";
}

else {
  var len = 0,  cmStr = "";
  Redraw = false;

  // コメントマークの先頭の空白文字を除去
  // ※comment の先頭に空白文字（半角空白、タブ文字、改行）があるとアンコメントできない
  comment = comment.replace( /^\s+/ , "" );
  // コメントマークの末尾が空白文字の場合、末尾空白なしのコメントマークを定義
  if ( varEnable && /\s+$/.test( comment ) ) {
    comStr = comment.replace( /\s+$/ , "" );
  }

  // 選択範囲
  var s = editor.ActiveDocument.selection;
  var tx = s.GetTopPointX( mePosLogical );
  var ty = s.GetTopPointY( mePosLogical );
  var bx = s.GetBottomPointX( mePosLogical );
  var by = s.GetBottomPointY( mePosLogical );
  var anc = s.GetAnchorPos();
  var act = s.GetActivePos();
  var pos = s.IsEmpty;	// 範囲選択なしのフラグ
  var sx = ScrollX,  sy = ScrollY;

  // １行内で範囲選択しているとき（インラインモード） ※選択範囲を拡張しない
  var inLine = ( ! pos && inLineEnable && ty == by );

  // 範囲選択なし または 複数行選択のとき（行全体のコメントアウト）
  if ( ! inLine ) {

    // 選択範囲の末尾が行頭にあるときの調整
    if ( ty < by && bx == 1 ) {
      by --;
    }
    // 選択範囲を拡張
    s.SetActivePoint( mePosLogical, 1, by );
    s.EndOfLine( false, mePosLogical );
    s.SetAnchorPoint( mePosLogical, 1, ty );

    // ブックマーク行を収集（選択範囲の先頭行は確認しない）
    if ( ty < by ) {
      var tp = s.GetAnchorPos(),  bp = s.GetActivePos();
      var bmArray = [];
      s.SetActivePos( tp );
      while ( s.NextBookmark() && s.GetActivePointY( mePosLogical ) <= by ) {
        bmArray.push( s.GetActivePointY( mePosLogical ) );
      }
      len = bmArray.length;
      s.SetAnchorPos( tp );  s.SetActivePos( bp, true );
      ScrollX = sx;  ScrollY = sy;
    }
  }

  // コメントアウト／アンコメント
  var st = s.Text;		// 選択範囲の文字列
  var ad = AddDeleteComment( st, mode, comment, comStr, $ctrl );
  if ( ad != st ) {		// 変更なしなら undo 履歴に残さない
    s.Text = ad;
  }

  // ブックマークを復元
  if ( len ) {
    var ep = s.GetActivePos();
    for ( var i = 0, len = bmArray.length; i < len; i ++ ) {
      s.SetActivePoint( mePosLogical, 1, bmArray[i], false );
      s.SetBookmark();
    }
    s.SetActivePos( ep );
  }

  var gap = ad.length - st.length;

  // 選択範囲なしで実行したときは選択範囲を残さない	 (◆2019/04/15 変更)
  if ( pos ) {
    var id = 1 + d.GetLine( ty, 0 ).search( /[^\s]/ );
    var x = ( gap > 0 && tx >= id ) ? tx + gap :	// コメントアウト
            ( tx > gap && tx > id ) ? tx + gap : tx;	// アンコメント
    s.SetActivePoint( mePosLogical, x, ty );
  }
  // 選択範囲が１行だけのときは選択範囲を復旧する
  else if ( inLine ) {
    s.SetActivePos( ( anc < act ) ? act + gap : act );
    s.SetAnchorPos( ( anc < act ) ? anc : anc + gap );
  }
  // 複数行選択なら拡張した選択範囲を復旧する
  else {
    s.SetActivePoint( mePosLogical, 1, by + 1 );
    s.SetAnchorPoint( mePosLogical, 1, ty );
  }
  ScrollX = sx;  ScrollY = sy;
  Redraw = true;

  var elapsedSec = ( ( new Date() - start ) / 1000 ).toFixed( 3 );
  Status = "　「行コメント」マクロ　　[ "
         + elapsedSec.replace( /\./, ". " )
         + " 秒 ]";
}


// ---------- ▼ 関数 ▼ ---------- //

/**
 * 関数 AddDeleteComment( str )
 * 選択範囲の各行の字下げ量をチェックして、字下げ位置にあわせてコメントアウトする
 * コメントマークのチェックには正規表現を使っていないので、誤爆はほぼないはず
 * ※ 変数 comment の先頭が空白文字（半角スペースやタブ、改行コード）だとアンコメントできない
 *   → メインスコープに comment 先頭の空白除去の処理を追加
 * ※ Ctrl キーでの強制コメントアウトを追加
 */ 
function AddDeleteComment( str, mode, comment, comStr, $ctrl ) {
  // Ctrl キー押し下げで強制コメントアウト（※行頭にコメントマーク追加）
  if ( $ctrl == 1 ) {
    return str.replace( /^/gm , comment );
  }

  var id, c0, d0;		// 字下げ量（空白以外の文字の最初の出現位置）
  var a = str.split( "\n" );	// 選択範囲を行単位に分解して配列 a に
  var b = [];	// 各行の字下げ量 id を格納する			→ 削除の基準 b[i]
  var c = [];	// id をソートして最小の字下げ量を調べる	→ 追加の基準 c[0]
  var d = [];	// 非コメント行の字下げ量 _id を格納する	→ 追加の基準 d[0]
  var len = a.length;
  var comLength = comment.length;
  var comStrLength = comStr.length;

  // 選択範囲内の各行の字下げ量を取得	→ 配列 b, c, d に
  for ( var i = 0; i < len; i ++ ) {
    // 各行ごとの字下げ量
    id = a[i].indexOf( a[i].match( /[^ \t]/ ) );

    // 空白行では -1 が返されるので、id をデタラメな値（∞）にして配列 b, c に格納する
    // （-1 は sort のジャマ、JScript では substr の第１引数に使用できない）
    id = ( id < 0 ) ? Infinity : id;	// 空白行はコメントアウトしないから数値は大きく
    b.push( id );
    if ( mode == 2 ) {
      c.push( id );
    }
    // コメント行の数値もデタラメな値（∞）にして _id を配列 d に格納
    else if ( mode == 3 ) {
      id = ( a[i].substr( b[i], comLength ) == comment ) ? Infinity : id;
      d.push( id );
    }
  }	// end for

  // 配列 c, d を昇順で並びかえ（ → 最小値 c[0] d[0] だけ使う）
  var CompareForSort = function( first, second ) {
    return  ( first == second ) ?  0
          : ( first < second )  ? -1
          :/* first > second */    1; 
  }
  if ( mode == 2 ) {
    c0 = c.sort( CompareForSort )[0];
  }
  else if ( mode == 3 ) {
    d0 = d.sort( CompareForSort )[0];
  }

  // 各行をコメントアウト／アンコメント処理
  for ( var i = 0, ai, bi; i < len; i ++ ) {
    ai = a[i],  bi = b[i];
    if ( bi == Infinity ) { continue; }	// 空白行はスキップ

    // 行頭の空白 b[i] の直後がコメントマークかチェック
    // "// コメント行" なら...
    if ( ai.substr( bi, comLength ) == comment ) {
      // ( mode > 0 ) または コメントマークが行頭 ならアンコメント
      // ( mode = 0 ) で コメントマークが行頭以外 ならコメントアウト
      a[i] = ( mode != 0 || bi == 0 )
           ? ai.substr( 0, bi ) + ai.substr( bi + comLength )
           : comment + ai;	// ← ( mode == 0 && bi != 0 )
    }

    // 定義されたコメントマークの末尾が空白文字つき "// " ならば
    // 各行が末尾空白なしの "//" でコメントアウトされているか再チェック
    else if ( comStr && ai.substr( bi, comStrLength ) == comStr ) {
      // アンコメント または コメントアウト
      a[i] = ( mode != 0 || bi == 0 )
           ? ai.substr( 0, bi ) + ai.substr( bi + comStrLength )
           : comment + ai;	// ← ( mode == 0 && bi != 0 )
    }

    // 非コメント行なら字下げ位置にあわせてコメントマークを追加する
    else {
      a[i] = ( mode == 4 ) ? ai.slice( 0, bi ) + comment + ai.slice( bi )
           : ( mode == 3 ) ? ai.slice( 0, d0 ) + comment + ai.slice( d0 )
           : ( mode == 2 ) ? ai.slice( 0, c0 ) + comment + ai.slice( c0 )
           : /*  else  */    comment + ai;
    }

  }	// end for
  return a.join( "\n" );
}	// end function


// ---------- ▼ コメントドキュメント ▼ ---------- //

/**
 * ・行のコメントアウト状態を反転します。
 * 
 * ・手石／masme 版の「字下げされたコメントマークを削除できる」機能を下地として、
 *   選択範囲のもっとも字下げの少ない位置にあわせてコメントマークを付けられます。
 *   ※ 字下げへの対応においては、「Eclipse風コメントアウト」マクロよりも
 *      オプション設定の拡張性が高く、融通が利く仕様となっています。
 * 
 * ・空白行（タブ文字／半角スペースのみの行と、完全な空行）は無視します。
 * 
 * ・インラインコメントアウト／アンコメント（行の途中からのコメントアウト）機能を追加しました。
 *   ※ 選択範囲が１行内の場合は、選択範囲の先頭位置でコメントアウト／アンコメントします。
 * 
 * ・範囲選択なしや複数行選択の状態なら、行頭でコメントアウト／アンコメントします。
 *   ※ 選択範囲の先頭が空白文字なら字下げオプションに準じて処理します。
 * 
 * ・選択範囲内の各行のブックマークを維持します。
 * 
 * ・Ctrl キーを押しながら実行したときは、コメントアウト状態の反転ではなく
 *   選択範囲をふくむ行全体（１行内なら選択範囲内）を強制的にコメントアウトします。
 *   "// コメント行" を含むコードブロックをまとめてコメントアウトするさい、
 *   既存の "// コメント行" は "// // 二重にコメントアウト" できます。
 *   ※ 強制コメントアウトでコメントマークを挿入する位置は、行頭（選択範囲の先頭）に限定されます。
 * 
 *   ※ Ctrl キーの押し下げ状態でマクロの機能を切り替えるので、
 *      このマクロにショートカットキーを割り当てる場合は、
 *      Ctrl キーをふくむキーパターンと Ctrl キーをふくまないキーパターンの
 *      ２つを登録する必要があります。
 *         e.g.1 「Ctrl + /」キー  と  「Alt + /」キー
 *         e.g.2 「Ctrl + Alt + /」キー  と  「Alt + /」キー
 * 
 *   ※ GetKeyState.exe をインストールしない場合は
 *      強制コメントアウト機能を利用できません。
 * 
 * ・編集モードによるコメントマークの定義切替は、masme 版より改変。
 *    "編集モードによる定義切替は、マクロ「Eclipse風コメントアウト」を参考にしました。" とのこと。
 * 
 * ・変数 comment の定義に "> " などの引用マークを指定すると、引用マークの付けはずしにも使用できます。
 * 
 * ・comment 定義の末尾に空白×１ "//␣" をつけて指定すると、
 *   "//␣こういうコメント行"  と
 *   "//こういうコメント行"  の両方ををアンコメントできます（◆ 人柱版 ◆ 追加コード）。
 * 
 * 
 * ▼ 注意事項（仕様上の制限） ▼
 * 
 * ※ 動作モードの優先順位
 *   ① Ctrl キーを押しながらの強制コメントアウト（行の先頭で強制コメントアウト）
 *   ② インラインコメントアウト／アンコメント（行の途中からのコメントアウト）
 *   ③ 字下げオプションに応じたコメントアウト／アンコメントのトグル（反転）
 * 
 *   ※ 行の途中からの "// インラインコメント" 部分（１行内）を範囲選択している状態で
 *      Ctrl キーを押しながらマクロを実行した場合は、選択範囲の先頭にコメントマークを追加します。
 * 
 * ※ 字下げルールが「半角スペースのみ」または「タブ文字のみ」であるか、
 *   混在する場合には「半角スペースとタブ文字の出現順序が同じである」という前提になっています。
 *   タブ文字ひとつを半角スペースひとつと同じように数え、表示上の幅で評価しません。
 * 
 * ※ 行コメント文字の変数 comment = "" の先頭が空白文字だとアンコメントできないので
 *    comment 定義の先頭の空白文字は無視します。
 * 
 * ※ 末尾空白２つ以上 "//␣␣" で定義して "//␣こういうコメント行" をアンコメントした場合
 *   行頭に空白がひとつ残ります。
 *   → 字下げ対応で再度コメントアウトすると、ひとつ字下げした位置にコメントマークが付きます。
 * 
 * ※ コメントマークの「付け／はずし」を各行に対してトグル（反転）するので、
 *   以下のような段落をまとめて操作すると、１～３行目はアンコメントし、
 *   ４行目以降はコメントアウトします。

※ コメントマークの定義  "// "  （末尾に半角スペースつき）

例０-１. 字下げに非対応だと…	※ mode = 0;  varEnable = false;  のばあい
//コメント０           =>      |// //コメント０      =>        |//コメント０   
// コメント１          =>      |コメント１           =>        |// コメント１  
  // コメント２        =>      |//  // コメント２    =>        |  // コメント２
  

例０-２. 字下げには非対応でも…	※ mode = 0;  varEnable = true;  (sukemaru版 独自拡張)
//コメント０           =>      |コメント０           =>        |// コメント０  
// コメント１          =>      |コメント１           =>        |// コメント１  
  // コメント２        =>      |//  // コメント２    =>        |  // コメント２


例１-１. ６行まとめて選択すると…	※ mode = 1;  varEnable = false;  (従来版とおなじ動作)
//コメント０           =>      |// //コメント０      =>        |//コメント０   
// コメント１          =>      |コメント１           =>        |// コメント１  
  // コメント２        =>      |  コメント２         =>        |//   コメント２
  hoge                 =>      |//   hoge            =>        |  hoge         
    fuga               =>      |//     fuga          =>        |    fuga       
      piyo             =>      |//       piyo        =>        |      piyo     


例１-２. ６行まとめて選択でも…		※ mode = 1;  varEnable = true;  (sukemaru版 独自拡張)
//コメント０           =>      |コメント０           =>        |// コメント０  
// コメント１          =>      |コメント１           =>        |// コメント１  
  // コメント２        =>      |  コメント２         =>        |//   コメント２
  hoge                 =>      |//   hoge            =>        |  hoge         
    fuga               =>      |//     fuga          =>        |    fuga       
      piyo             =>      |//       piyo        =>        |      piyo     
									

例２-１. 下３行だけを選択すれば…	※ mode = 2 or 3;  (sukemaru版 独自拡張)
//コメント０           =>      |//コメント０         =>        |//コメント０   
// コメント１          =>      |// コメント１        =>        |// コメント１  
  // コメント２        =>      |  // コメント２      =>        |  // コメント２
  hoge                 =>      |  // hoge            =>        |  hoge         
    fuga               =>      |  //   fuga          =>        |    fuga       
      piyo             =>      |  //     piyo        =>        |      piyo     


例２-２. 下４行を選択だと…	※ mode = 2 or 3;  (sukemaru版 独自拡張)
//コメント０           =>      |//コメント０         =>        |//コメント０   
// コメント１          =>      |// コメント１        =>        |// コメント１  
  // コメント２        =>      |  コメント２         =>        |  // コメント２
  hoge                 =>      |  // hoge            =>        |  hoge         
    fuga               =>      |  //   fuga          =>        |    fuga       
      piyo             =>      |  //     piyo        =>        |      piyo     


例３. ６行まとめて選択しても、コメントアウトとアンコメントで別々の先頭位置を使うこともできる
	※ mode = 3;  varEnable = true;  (sukemaru版 独自拡張)
//コメント０           =>      |コメント０           =>        |// コメント０  
// コメント１          =>      |コメント１           =>        |// コメント１  
  // コメント２        =>      |  コメント２         =>        |//   コメント２
  hoge                 =>      |  // hoge            =>        |  hoge         
    fuga               =>      |  //   fuga          =>        |    fuga       
      piyo             =>      |  //     piyo        =>        |      piyo     


例４. 一応、こういうこともできる
	※ mode = 4;  varEnable = true;  (sukemaru版 独自拡張)
//コメント０           =>      |コメント０           =>        |// コメント０  
// コメント１          =>      |コメント１           =>        |// コメント１  
  // コメント２        =>      |  コメント２         =>        |  // コメント２
  hoge                 =>      |  // hoge            =>        |  hoge         
    fuga               =>      |    // fuga          =>        |    fuga       
      piyo             =>      |      // piyo        =>        |      piyo     


例５. コードブロックをまとめて強制的にコメントアウトするなら
	※ Ctrl キーを押しながらマクロを実行  (sukemaru版 独自拡張)
//コメント０           =>      |// //コメント０      =>        |//コメント０   
// コメント１          =>      |// // コメント１     =>        |// コメント１  
  // コメント２        =>      |//   // コメント２   =>        |  // コメント２
  hoge                 =>      |//   hoge            =>        |  hoge         
   fuga                =>      |//     fuga          =>        |    fuga       
     piyo              =>      |//       piyo        =>        |      piyo     


××× このマクロでは、こういうことはできません ×××
	※ ６行まとめて選択しているとき…
//コメント０           =>      |//コメント０         =>        |コメント０     
// コメント１          =>      |// コメント１        =>        | コメント１    
  // コメント２        =>      |//  // コメント２    =>        |  // コメント２
  hoge                 =>      |//  hoge             =>        |  hoge         
   fuga                =>      |//    fuga           =>        |    fuga       
     piyo              =>      |//      piyo         =>        |      piyo     

 */
